package OLS;


public class Function
{
    double[] factors;
    FuncBasis myBasis;
    public Function(FuncBasis basis, double[] factors)
    {
        this.factors = factors;
        this.myBasis = basis;
    }

    public double getValue(double x)
    {
        double returnValue = 0;
        for(int i = 0; i < factors.length; i++)
            returnValue += factors[i]*myBasis.getFuncValue(i,x);
        return returnValue;
    }

    @Override
    public String toString()
    {
        StringBuilder builder = new StringBuilder();
        for(int i = 0; i < factors.length; i++)
        {
            char ch = '+';
            if(i == factors.length -1) ch = ';';
            builder.append("x^" + i + "*" + factors[i] + ch);
        }
            builder.append('\n');
        return builder.toString();
    }
}
