package OLS;

import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

import javax.swing.*;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class Main
{

    /*
        Писалось в отчаянии
     */
    public static void main(String[] args)
    {
        BufferedReader reader = null;
        try
        {
            reader = new BufferedReader(new FileReader(args[0]));
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }

        int n,pd; // n - points, m - polynominal degree
        try{
            String str = reader.readLine();
            String[] dimension = str.split("x");
            n = Integer.parseInt(dimension[0]);
            pd = Integer.parseInt(dimension[1]);
        }
        catch(Exception ex)
        {
            System.out.println("Ошибка чтения");
            return;
        }


        double[] data_x = new double[n];
        double[] data_y = new double[n];

        int i = 0;

        String read = null;
        do
        {
            try
            {
                if((read = reader.readLine()) == null)
                    continue;
                String[] nums = read.split(" ");
                data_x[i] = Double.parseDouble(nums[0]);
                data_y[i] = Double.parseDouble(nums[1]);
            }
            catch(Exception ex)
            {
                ex.printStackTrace();
            }
            i++;
        }while(read != null);

        try{
            reader.close();
        }
        catch(IOException ex)
        {
            System.out.println("Ошибка закрытия файла");
        }



        Approximator myAppr = new Approximator(new FuncBasis(pd),data_x,data_y);
        double[] factors = myAppr.getFactors();
        Function myFunc = new Function(myAppr.getBasis(),factors);

        XYSeriesCollection collection = new XYSeriesCollection();
        XYSeries oldSeries = new XYSeries("Old data");
        XYSeries appSeries = new XYSeries("Approximated Data");
        double step = Math.pow(10,-3);
        double x;

        for(x = -1; x < 5; x += step)
        {
            appSeries.add(x,myFunc.getValue(x));
        }

        for(i = 0; i < data_y.length;i++)
        {
            oldSeries.add(data_x[i],data_y[i]);
        }
        collection.addSeries(appSeries);
        collection.addSeries(oldSeries);
        GraphFrame frame = new GraphFrame(collection);
        frame.setVisible(true);
        System.out.println(myFunc.toString());
    }
}
