package OLS.SetEquSolver;

public class SolveGauss implements Solver
{
    @Override
    public Matrix Solve(Matrix A, Matrix B, double precision)
    {
        double[][] MatrixA = A.getValues();
        double[][] MatrixB = B.getValues();
        ForwardMove(MatrixA,MatrixB);
        double[][] X = BackMove(MatrixA,MatrixB);
        return new Matrix(X);
    }

    void ForwardMove(double[][] MatrixA,double[][] MatrixB)
    {


        for(int line_index = 0; line_index < MatrixA.length;line_index++)
        {

            /*
                Search and swap
                Partial pivoting
             */
            /*
            int i = line_index;
            double max = MatrixA[i][line_index];
            int max_index = line_index;
            for(; i < MatrixA[0].length; i++)
            {
                if (MatrixA[i][line_index] > max)
                {
                    max = MatrixA[i][line_index];
                    max_index = i;
                }
            }
            if (MatrixA[max_index] != MatrixA[line_index])
                swapStrings(MatrixA[max_index], MatrixA[line_index]);
                  */

            /*
                Processing
             */
            int i;
            double factor = MatrixA[line_index][line_index];
            for(i = line_index; i < MatrixA[0].length; i++)
            {
                MatrixA[line_index][i] /= factor;
            }
            MatrixB[line_index][0] /= factor;

            for(i = line_index + 1; i < MatrixA.length; i++ )
            {
                MatrixB[i][0] -= MatrixB[line_index][0]*MatrixA[i][line_index];
                factor = MatrixA[i][line_index];
                for(int column_index = line_index; column_index < MatrixA[0].length; column_index++)
                    MatrixA[i][column_index] -=  MatrixA[line_index][column_index]*factor;
            }
        }

    }

    double[][] BackMove(double[][] MatrixA,double[][] MatrixB)
    {
        double[][] returnMatrix = new double[MatrixA.length][1];

        returnMatrix[MatrixA.length-1][0] = MatrixB[MatrixA.length-1][0]/MatrixA[MatrixA.length-1][MatrixA.length-1];

        for(int line_index = MatrixA.length - 1;line_index >= 0; line_index--)
        {
            double sum = 0;

            for(int column_index = MatrixA[0].length - 1 ; column_index > line_index; column_index--)
                sum += returnMatrix[column_index][0]*MatrixA[line_index][column_index];

            returnMatrix[line_index][0] = (MatrixB[line_index][0]-sum)/MatrixA[line_index][line_index];
        }

        return returnMatrix;
    }

    /*
        A little pointers magic
     */
    void swapStrings(double[] fst_string, double[] snd_string)
    {
        double[] tmp_pointer;
        tmp_pointer = fst_string;
        fst_string = snd_string;
        snd_string = tmp_pointer;
    }
}
